#include <windows.h>


/*Ȃ񂩐錾݂Ȃ*/
LRESULT CALLBACK MainWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

class Region
{
	private:
		BITMAP m_Bitmap;
		HBITMAP m_hBitmap;
		HDC m_hDC;
		HRGN m_hRgn;
	public:
		bool Load(HWND hWnd,const char *cpBmpFile);
		bool Paint(HWND hWnd);
		HRGN MakeRegion(HBITMAP hBitmap);
		bool Free();

		int GetWidth();
		int GetHeight();
};


/*CBꂾ*/
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	HWND hWnd;
	DWORD dwRet;
	MSG msg;
	WNDCLASSEX wce;
	const char *cszClassName = "[ƃfXNgbvkqwdkoqd";
	const char *cszWindowTitle = "";

	wce.cbSize = sizeof(WNDCLASSEX);
	wce.cbClsExtra = 0;
	wce.cbWndExtra = 0;
	wce.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wce.hCursor = LoadCursor(NULL,IDC_ARROW);
	wce.hIcon = 0;
	wce.hIconSm = 0;
	wce.hInstance = hInstance;
	wce.lpfnWndProc = MainWndProc;
	wce.lpszClassName = cszClassName;
	wce.lpszMenuName = NULL;
	wce.style = CS_HREDRAW | CS_VREDRAW;
	if (!RegisterClassEx(&wce))return EXIT_FAILURE;


	/*EBhEBꂾB*/
	hWnd = CreateWindowEx(WS_EX_TOOLWINDOW,cszClassName,cszWindowTitle,WS_VISIBLE
		,CW_USEDEFAULT,CW_USEDEFAULT,100,100
		,NULL,NULL,hInstance,NULL);

	/**/
	while(dwRet = GetMessage(&msg,hWnd,0,0))
	{
		if(dwRet == -1)break;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

/*vV[WH*/
LRESULT CALLBACK MainWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static Region rgn;

	switch(uMsg)
	{
		case WM_CREATE:
			if(!rgn.Load(hWnd,"imouto.bmp"))
			{
				MessageBox(hWnd,"imouto.bmp܂","err",MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			rgn.Paint(hWnd);
		break;

		case WM_PAINT:
			rgn.Paint(hWnd);
		break;

		case WM_RBUTTONUP:
			SendMessage(hWnd,WM_CLOSE,0,0);
		break;

		case WM_LBUTTONDOWN:
			PostMessage(hWnd,WM_NCLBUTTONDOWN,(WPARAM)HTCAPTION,lParam);
		break;

		case WM_MOVING:
			{
				RECT rc;
				SystemParametersInfo(SPI_GETWORKAREA,0,&rc,0);
				LPRECT lrc = (LPRECT)lParam;
				lrc->top = rc.bottom-rgn.GetHeight();
				lrc->bottom = rc.bottom;
				return TRUE;
			}
		break;

		case WM_DESTROY:
			PostQuitMessage(EXIT_SUCCESS);
		break;
	}

	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}






/********************************************
 * 艺 class Region ̓e
 ********************************************/

/*ǂ*/
bool Region::Load(HWND hWnd,const char *cpBmpFile)
{
	HINSTANCE hInst = (HINSTANCE)GetWindowLong(hWnd,GWL_HINSTANCE);

	m_hBitmap = (HBITMAP)LoadImage(hInst,cpBmpFile,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION | LR_LOADFROMFILE);
	if(m_hBitmap == NULL)return false;

	GetObject(m_hBitmap,sizeof(BITMAP),&m_Bitmap);

	HDC hDC;
	hDC = GetWindowDC(hWnd);
	m_hDC = CreateCompatibleDC(hDC);
	ReleaseDC(hWnd,hDC);

	m_hRgn = MakeRegion(m_hBitmap);

	return true;
}

/*s`[W*/
HRGN Region::MakeRegion(HBITMAP hBitmap)
{
	BYTE *lpBmpPixel;
	char MR,MG,MB; //}XNJ[(̐F)
	char DR,DG,DB; //F
	DIBSECTION dibSec;

	/*DIBSectionēFݒ*/
	GetObject(hBitmap,sizeof(DIBSECTION),&dibSec);
	lpBmpPixel = (BYTE*)dibSec.dsBm.bmBits;
	MB = lpBmpPixel[0];
	MG = lpBmpPixel[1];
	MR = lpBmpPixel[2];

	int nHeight = dibSec.dsBm.bmHeight;
	int nWidth = dibSec.dsBm.bmWidth;
	int nStart;

	HRGN hRgn = CreateRectRgn(0,0,0,0); //
	HRGN hRgnTemp;

	for(int py=0;py<nHeight;py++)
	{
		nStart = -1;
		for(int px=0;px<nWidth;px++)
		{
			DB = lpBmpPixel[(px+py*nWidth)*3];
			DG = lpBmpPixel[(px+py*nWidth)*3+1];
			DR = lpBmpPixel[(px+py*nWidth)*3+2];

			/*Fv*/
			if(DB != MB || DG != MG || DR != MR)
			{
				if(nStart<0)
					nStart = px;
			}

			/*Fsv*/
			else
			{
				/*}XN*/
				if(nStart>=0)
				{
					hRgnTemp = CreateRectRgn(nStart,nHeight-py,px,nHeight-py+1);
					CombineRgn(hRgn,hRgn,hRgnTemp,RGN_OR);
					DeleteObject(hRgnTemp);
					nStart = -1;
				}
			}
		}

		/*Ǝc*/
		if(nStart>=0)
		{
			hRgnTemp = CreateRectRgn(nStart,nHeight-py,px,nHeight-py+1);
			CombineRgn(hRgn,hRgn,hRgnTemp,RGN_OR);
			DeleteObject(hRgnTemp);
		}
	}

	return hRgn;
}

/*\*/
bool Region::Paint(HWND hWnd)
{
	/*EBhE摜̃TCYɃTCY*/
	RECT rc;
	SystemParametersInfo(SPI_GETWORKAREA,0,&rc,0);
	int nScreenHeight = rc.bottom;
	GetWindowRect(hWnd,&rc);
	MoveWindow(hWnd,rc.left,nScreenHeight-m_Bitmap.bmHeight,m_Bitmap.bmWidth,m_Bitmap.bmHeight,FALSE);

	SetWindowRgn(hWnd,m_hRgn,FALSE);

	HDC hDC;
	hDC = GetWindowDC(hWnd);
	HBITMAP hOldBitmap = (HBITMAP)SelectObject(m_hDC,m_hBitmap);

	BitBlt(hDC,0,0,m_Bitmap.bmWidth,m_Bitmap.bmHeight,m_hDC,0,0,SRCCOPY);

	ReleaseDC(hWnd,hDC);

	SelectObject(m_hDC,hOldBitmap);
	return true;
}

/**/
bool Region::Free()
{
	DeleteObject(m_hBitmap);
	DeleteDC(m_hDC);
	DeleteObject(m_hRgn);
	return true;
}

/*݂Ȃ*/
int Region::GetHeight()
{
	return m_Bitmap.bmHeight;
}

/*݂Ȃ*/
int Region::GetWidth()
{
	return m_Bitmap.bmWidth;
}